/* ----------------------------------------------------------------------
     MIME Mangler - single pass reduction of MIME to plain text

     Laurence Lundblade <lgl@qualcomm.com>

     Copyright 1997, QUALCOMM Inc.

     File: utils.h - a few string utilities
     Version: 0.2.3, Dec 1997
     Last Edited: Nov 13 12:17

  ---- */


#ifndef _UTILSINCLUDED
#define _UTILSINCLUDED
#include <config.h>
/*------------   Types   ------------*/

typedef const char *CSTR;
typedef char *STR;

#define TRUE  1
#define FALSE 0


typedef int BOOL;


#define CHARISSPACE(c)   ((c) == 32 || (c) == '\t' || (c) == '\r' || (c) == '\n')

/* BETWEEN : TRUE is val >= min and < max */
#define BETWEEN(val, min, max)   ( ((unsigned) ((val) - (min))) < (unsigned) ((max) - (min)) )


BOOL CharEQI __PROTO((char c1, char c2));

BOOL CharIsAlpha __PROTO((char ch));

BOOL CharIsSgmlTok __PROTO((char ch));

BOOL CharIsAlnum __PROTO((char ch));

BOOL CharIsDigit __PROTO((char ch));

int Constrain __PROTO((int nVal, int nMin, int nMax));

int StrEQI __PROTO((CSTR s1, CSTR s2));

BOOL StrBeginsI __PROTO((char *szPrefix, char *sz));

int ScanInt __PROTO((CSTR *pszEnt));

void StrNCat0 __PROTO((char *dest, const char *src, const int len));

/*
 * <CAUTION>StrNDup(): Acts the same as strdup(); 
 *  required to free the result </CAUTION>
 */
char *StrNDup __PROTO((char *src, const int len));

#ifdef UNIX
void MemSet __PROTO((char *dest, unsigned int len, char value));
#endif /* UNIX */

#endif /* _UTILSINCLUDED */
